declare const type: unique symbol;
declare const util: unique symbol;
declare const child: unique symbol;
declare const empty: unique symbol;
declare const trig: unique symbol;
declare const pureproxy: unique symbol;

var version = "0.0.34";

/*
 * @Author: tackchen
 * @Date: 2022-10-11 16:41:40
 * @Description: Coding something
 */
interface IJson<T = any> {
    [prop: string | symbol]: T;
}

declare enum AlinsType {
    Proxy = 1,
    Ref = 2,
    BindResult = 3
}

/*
 * @Author: tackchen
 * @Date: 2022-10-23 19:26:19
 * @Description: Coding something
 */


type ISimpleValue = string|number|boolean;

type IOnChange<T = string> = (nv: T, ov: T, path: string, prop: string, remove?: boolean) => void;

// Reactive
interface IProxyUtils {
  path: string[];
  lns: IProxyListenerMap;
  commonLns?: Set<IOnChange>;
  triggerChange: (property: string, nv: any, old?: any, remove?: boolean, isNew?: boolean) => void;
  forceWrite: (v: any, k?: string) => void;
  subscribe: (ln: IProxyListener<any>, deep?: boolean) => void;
  isArray: boolean;
  shallow: boolean;
  forceUpdate: ()=>void;
  // clearCache: ()=>void;
  proxy: IProxyData<any>;
  scopeItems?: any[];
  replaceLns?: boolean;
  extraLns?: Set<IProxyListenerMap>;
  data: any;
}

interface IProxyBase<T extends AlinsType.Proxy|AlinsType.Ref> {
  // @ts-ignore
  [util]: IProxyUtils;
  // @ts-ignore
  [type]: T;
}

interface IRefData<T=any> extends IProxyBase<AlinsType.Ref> {
  v: T;
}


type IProxyData<
    T,
    K = T extends object ? (T & IProxyBase<AlinsType.Proxy>) : IRefData<T>
> = K;

type IProxyListener<T = any> = IOnChange<T>;
type IProxyListenerMap = IJson<Set<IOnChange>>;

export { AlinsType, IJson, IOnChange, IProxyBase, IProxyData, IProxyListener, IProxyListenerMap, IProxyUtils, IRefData, ISimpleValue, child, empty, pureproxy, trig, type, util, version };
